package com.cholocb.util.crypto;

import java.io.UnsupportedEncodingException;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.NoSuchAlgorithmException;
import java.security.spec.AlgorithmParameterSpec;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

public class AES256Util {

	public static String encryptAES256(String sStr, String sKey, String sIV) {
		try {
			byte[] bByte = sStr.getBytes("UTF-8");
			byte[] bKey = HexUtil.decodeHex(sKey);
			byte[] bIV = HexUtil.decodeHex(sIV);

			AlgorithmParameterSpec ivSpec = new IvParameterSpec(bIV);
			SecretKeySpec sksKey = new SecretKeySpec(bKey, "AES");
			Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
			cipher.init(Cipher.ENCRYPT_MODE, sksKey, ivSpec);
			byte[] bEnc = cipher.doFinal(bByte);
			return Base64Util.encodeBase64(bEnc);
		} catch (NoSuchAlgorithmException | NoSuchPaddingException | InvalidKeyException | InvalidAlgorithmParameterException | UnsupportedEncodingException | IllegalBlockSizeException | BadPaddingException e ) {
			e.printStackTrace();
		}

		return "";
	}

	public static String decryptAES256(String sStr, String sKey, String sIV) {
		
		byte[] bByte = Base64Util.decodeBase64(sStr);
		byte[] bKey = HexUtil.decodeHex(sKey);
		byte[] bIV = HexUtil.decodeHex(sIV);

		AlgorithmParameterSpec ivSpec = new IvParameterSpec(bIV);
		SecretKeySpec sksKey = new SecretKeySpec(bKey, "AES");
		Cipher cipher;
		try {
			cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
			cipher.init(Cipher.DECRYPT_MODE, sksKey, ivSpec);
			byte[] bDec = cipher.doFinal(bByte);
			return new String(bDec, "UTF-8");
		} catch (NoSuchAlgorithmException | NoSuchPaddingException | InvalidKeyException | InvalidAlgorithmParameterException | IllegalBlockSizeException | BadPaddingException | UnsupportedEncodingException e) {
			e.printStackTrace();
		}

		return "";
	}

}
