package com.cholocb.util.crypto;

import java.io.UnsupportedEncodingException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

public class HmacSha256Util {

	private static final String ALGORITHM = "HmacSHA256";
	
	public static String encryptHmacSHA256(String sStr, String sKey) {
		Mac mac = null;
		byte[] bKey = HexUtil.decodeHex(sKey);

		try {
			mac = Mac.getInstance(ALGORITHM);
			mac.init(new SecretKeySpec(bKey, ALGORITHM));
			byte[] hmacByte = mac.doFinal(sStr.getBytes("UTF-8"));
			return HexUtil.encodeHex(hmacByte);
		} catch (NoSuchAlgorithmException | InvalidKeyException | IllegalStateException | UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		return "";
	}

	public static String signFromJSONStr(String sJSON, String sKey) {
		Mac mac = null;
		byte[] bKey = HexUtil.decodeHex(sKey);
		String sSign = "";

		try {
			mac = Mac.getInstance(ALGORITHM);
			mac.init(new SecretKeySpec(bKey, ALGORITHM));
			byte[] hmacByte = mac.doFinal(sJSON.getBytes("UTF-8"));
			sSign = HexUtil.encodeHex(hmacByte);
		} catch (NoSuchAlgorithmException | InvalidKeyException | IllegalStateException | UnsupportedEncodingException e) {
			e.printStackTrace();
		}

		String sSignJSONStr = sJSON.substring(0, sJSON.length()-1)+",\"sign\":\""+sSign+"\"}";
		
		return sSignJSONStr;
	}

	public static String unSignFromJSONStr(String sSignJSON, String sKey) {
		Mac mac = null;
		byte[] bKey = HexUtil.decodeHex(sKey);
		String sJSON = sSignJSON.substring(0, sSignJSON.length()-75)+"}";
		String sSign = "";

		try {
			mac = Mac.getInstance(ALGORITHM);
			mac.init(new SecretKeySpec(bKey, ALGORITHM));
			byte[] hmacByte = mac.doFinal(sJSON.getBytes("UTF-8"));
			sSign = HexUtil.encodeHex(hmacByte);
		} catch (NoSuchAlgorithmException | InvalidKeyException | IllegalStateException | UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		if (sSignJSON.substring(sSignJSON.length()-66,sSignJSON.length()-2).equals(sSign)) {
			return sSign;
		} else {
			return "";
		}
	}

}
